      PROGRAM KORZDM
C     **************
      COMMON / INOUT / INUT,IOUT
      COMMON  / / BLAN(10000)
      REAL*4    E1(3),E2(3),PB1(4),PB2(4)
      REAL*4 XPR(40)
      INTEGER NPR(40)
C INPUT PARAMETERS OF GENERATOR
C FOR MORE COMMENTS SEE:
C   1)  KORALZ LONG WRITE UP
C   2)  CHAPTER 5 OF  TAUOLA LONG WRITE UP
C+++++++++++++++++++++++++++++++++++++++++++++++++++
C INITIALIZATION OF THE INPUT OUTPUT UNIT NUMBERS
      INUT=5
      IOUT=6
      CALL GLIMIT(20000)
      CALL GOUTPU(6)

      NEVTES=16 000
      ENE = 57.5
      ENE =  45.075+0.5 +5
      ENE = 91.17/2
      ene=184./2 ! 100 ! 90.5
      KEYGSW=1
      KEYRAD=0
      JAK1=1
      JAK2=1
      ISPIN= 1 
      INRAN= 1
      AMZ=91.177
      AMH=100
      AMTOP= 90
      XK0=0.01
      VVMIN=0.00001
      VVMAX=1.0

      vvmax=1.0 -(.85)**2
      vvmax=1.0 -(.1)**2
      GV= 1
      GA=-1
      SINW2=.232052785
      SINW2=.23

      sinw2=.2293d0
      GAMZ=2.482990487

      GAMZ=2.484
      KFB=-11
 !     KFB= 11
      AMNUTA=0.010
      ITDKRC=1
      XK0DEC=0.001
      DO 5 I=1,3
      E1(I)=0
   5  E2(I)=0
C     E2(3)=-1.00
C     E1(3)=0.55
!leptoquars switched on/off now ...
      ifleptok=1     ! switch on and off ( 1/0) lepttoquarks
      inter=-1     ! inter=-2,-1,1,2
      xmx=200    ! mass of leptoquark
      delta=-.2d0  ! additional parameter (size of coupling
! anomalous gamma couplings ifkalin=1 for neutrinos ifkalin=2 for taus
      ifkalin=0
      npr(13)=ifleptok
      npr(14)=inter
      npr(15)=ifkalin
      xpr(19)=xmx
      xpr(20)=delta
! other input for anomalous coupling is so far left in kzphynew(xpr,npr)
! routine -- thus easy to connect with koralz input, this routine is  
! in file .../lib/anomface.f
      PRINT 7001 ,NEVTES,ENE,KEYGSW,KEYRAD,ISPIN,INRAN,JAK1,JAK2,KFB
      PRINT 7002 , E2(1), E2(2), E2(3), E1(1), E1(2), E1(3)
C INITIALISATION OF THE GENERATOR
      NPR(1)=ISPIN
      NPR(2)=INRAN
      NPR(3)=KEYGSW
      NPR(4)=KEYRAD
      NPR(5)=JAK1
      NPR(6)=JAK2
      NPR(7)=505
      NPR(7)=1
      NPR(7)=501
      NPR(8)=ITDKRC
      NPR(9)=1
      IF (NPR(9).EQ.1) THEN
        PRINT *, 'FIRST LIBRARY'
      ELSE
        PRINT *, 'SECOND LIBRARY'
      ENDIF
      NPR(11)=3
!      NPR(11)=1
C KEYRAD OF YFS3
      NPR(12)=1000001
      XPR(1)=AMZ
      XPR(2)=AMH
      XPR(3)=AMTOP
      XPR(4)=GV
      XPR(5)=GA
      XPR(6)=SINW2
      XPR(7)=GAMZ
      XPR(8)=AMNUTA
C MASS OF NEUTRIONO OR QUARK
      XPR(9)=0.1
      XPR(11)=XK0
      XPR(12)=VVMIN
      XPR(13)=VVMAX
      XPR(14)=XK0DEC
      PB1(1)=0
      PB1(2)=0
      PB1(3)=ENE
      PB1(4)=ENE
      DO 7 I=1,3
   7  PB2(I)=-PB1(I)
      PB2(4)= PB1(4)
C LUND IDENTIFIER FOR ELECTRON KF = 11
      CALL KORALZ(-1,KFB,PB1,E1,-KFB,PB2,E2,XPR,NPR)
C     **********************************************
C+++++++++++++++++++++++++++++++++++++++++++++++++++
C MAIN LOOP
      DO 300 IEV=1,NEVTES
      CALL KORALZ(0 ,KFB,PB1,E1,-KFB,PB2,E2,XPR,NPR)
C     **********************************************

      NEV=IEV
      IPRI=MOD(NEV,500)
      IF(IPRI.EQ.1) PRINT *, ' event no: ',NEV,' NEVTES: ',NEVTES
C PRINTING FIRST EVENTS
      IF(IEV.LE.5)THEN
          CALL LUHEPC(2)
          CALL LULIST(2)
      ENDIF
  300 CONTINUE
C POSTGENERATION, PRINTOUTS
      CALL KORALZ( 1,0,PB1,E1,0,PB2,E2,XPR,NPR)
C     *****************************************

 7001 FORMAT(///1X,15(5HZZZZZ)
     $ /,' Z',25X     ,'=== KORALZ; DEMONSTRATION PROGRAM ===  ',9X,1HZ,
     $ /,' Z',I20  ,5X,'NEVTES  NO. OF EVENTS                  ',9X,1HZ,
     $ /,' Z',F20.5,5X,'ENE       CMS ENERGY                   ',9X,1HZ,
     $ /,' Z',I20  ,5X,'KEYGSW    GSW LEVEL                    ',9X,1HZ,
     $ /,' Z',I20  ,5X,'KEYRAD    BREMSS. ON/OFF               ',9X,1HZ,
     $ /,' Z',I20  ,5X,'ISPIN     FINAL STATE SPIN ON/OFF      ',9X,1HZ,
     $ /,' Z',I20  ,5X,'INRAN     RAND NUMB. INITIALIZ. CONST. ',9X,1HZ,
     $ /,' Z',I20  ,5X,'JAK1   DECAY TYPE TAU+                 ',9X,1HZ,
     $ /,' Z',I20  ,5X,'JAK2   DECAY TYPE TAU-                 ',9X,1HZ,
     $ /,' Z',I20  ,5X,'KFB    BEAM IDENTIFIER (LUND =+-7)     ',9X,1HZ,
     $ /,1X,15(5HZZZZZ)/)
 7002 FORMAT(///1X,15(5HZZZZZ)
     $ /,' Z',F20.5,5X,'E2(1)  ELECTR. POLARIZ. VEC.           ',9X,1HZ,
     $ /,' Z',F20.5,5X,'E2(2)                                  ',9X,1HZ,
     $ /,' Z',F20.5,5X,'E2(3)                                  ',9X,1HZ,
     $ /,' Z',F20.5,5X,'E1(1)  POSITR. POLARIZ. VEC.           ',9X,1HZ,
     $ /,' Z',F20.5,5X,'E1(2)                                  ',9X,1HZ,
     $ /,' Z',F20.5,5X,'E1(3)                                  ',9X,1HZ,
     $ /,1X,15(5HZZZZZ)/)
      END
      SUBROUTINE TAURDF(KTO)
C THIS ROUTINE CAN BE CALLED BEFORE ANY TAU+ OR TAU- EVENT IS GENERATED
C IT CAN BE USED TO GENERATE TAU+ AND TAU- SAMPLES OF DIFFERENT
C CONTENTS
      COMMON / TAUKLE / BRA1,BRK0,BRK0B,BRKS
      REAL*4            BRA1,BRK0,BRK0B,BRKS
      COMMON / TAUBRA / GAMPRT(30),JLIST(30),NCHAN
      IF (KTO.EQ.1) THEN
C     ==================
C LIST OF BRANCHING RATIOS
      NCHAN = 19
      DO 1 I = 1,30
      IF (I.LE.NCHAN) THEN
        JLIST(I) = I
        IF(I.EQ. 1) GAMPRT(I) = .0000
        IF(I.EQ. 2) GAMPRT(I) = .0000
        IF(I.EQ. 3) GAMPRT(I) = .0000
        IF(I.EQ. 4) GAMPRT(I) = .0000
        IF(I.EQ. 5) GAMPRT(I) = .0000
        IF(I.EQ. 6) GAMPRT(I) = .0000
        IF(I.EQ. 7) GAMPRT(I) = .0000
        IF(I.EQ. 8) GAMPRT(I) = 1.0000
        IF(I.EQ. 9) GAMPRT(I) = 1.0000
        IF(I.EQ.10) GAMPRT(I) = 1.0000
        IF(I.EQ.11) GAMPRT(I) = 1.0000
        IF(I.EQ.12) GAMPRT(I) = 1.0000
        IF(I.EQ.13) GAMPRT(I) = 1.0000
        IF(I.EQ.14) GAMPRT(I) = 1.0000
        IF(I.EQ.15) GAMPRT(I) = 1.0000
        IF(I.EQ.16) GAMPRT(I) = 1.0000
        IF(I.EQ.17) GAMPRT(I) = 1.0000
        IF(I.EQ.18) GAMPRT(I) = 1.0000
        IF(I.EQ.19) GAMPRT(I) = 1.0000
      ELSE
        JLIST(I) = 0
        GAMPRT(I) = 0.
      ENDIF
   1  CONTINUE
C --- COEFFICIENTS TO FIX RATIO OF:
C --- A1 3CHARGED/ A1 1CHARGED 2 NEUTRALS MATRIX ELEMENTS (MASLESS LIM.)
C --- PROBABILITY OF K0 TO BE KS
C --- PROBABILITY OF K0B TO BE KS
C --- RATIO OF COEFFICIENTS FOR K*--> K0 PI-
C --- ALL COEFFICENTS SHOULD BE IN THE RANGE (0.0,1.0)
C --- THEY MEANING IS PROBABILITY OF THE FIRST CHOICE ONLY IF ONE
C --- NEGLECTS MASS-PHASE SPACE EFFECTS
      BRA1=0.5
      BRK0=0.5
      BRK0B=0.5
      BRKS=0.6667
      ELSE
C     ====
C LIST OF BRANCHING RATIOS
      NCHAN = 19
      DO 2 I = 1,30
      IF (I.LE.NCHAN) THEN
        JLIST(I) = I
        IF(I.EQ. 1) GAMPRT(I) = .0000
        IF(I.EQ. 2) GAMPRT(I) = .0000
        IF(I.EQ. 3) GAMPRT(I) = .0000
        IF(I.EQ. 4) GAMPRT(I) = .0000
        IF(I.EQ. 5) GAMPRT(I) = .0000
        IF(I.EQ. 6) GAMPRT(I) = .0000
        IF(I.EQ. 7) GAMPRT(I) = .0000
        IF(I.EQ. 8) GAMPRT(I) = 1.0000
        IF(I.EQ. 9) GAMPRT(I) = 1.0000
        IF(I.EQ.10) GAMPRT(I) = 1.0000
        IF(I.EQ.11) GAMPRT(I) = 1.0000
        IF(I.EQ.12) GAMPRT(I) = 1.0000
        IF(I.EQ.13) GAMPRT(I) = 1.0000
        IF(I.EQ.14) GAMPRT(I) = 1.0000
        IF(I.EQ.15) GAMPRT(I) = 1.0000
        IF(I.EQ.16) GAMPRT(I) = 1.0000
        IF(I.EQ.17) GAMPRT(I) = 1.0000
        IF(I.EQ.18) GAMPRT(I) = 1.0000
        IF(I.EQ.19) GAMPRT(I) = 1.0000
      ELSE
        JLIST(I) = 0
        GAMPRT(I) = 0.
      ENDIF
   2  CONTINUE
C --- COEFFICIENTS TO FIX RATIO OF:
C --- A1 3CHARGED/ A1 1CHARGED 2 NEUTRALS MATRIX ELEMENTS (MASLESS LIM.)
C --- PROBABILITY OF K0 TO BE KS
C --- PROBABILITY OF K0B TO BE KS
C --- RATIO OF COEFFICIENTS FOR K*--> K0 PI-
C --- ALL COEFFICENTS SHOULD BE IN THE RANGE (0.0,1.0)
C --- THEY MEANING IS PROBABILITY OF THE FIRST CHOICE ONLY IF ONE
C --- NEGLECTS MASS-PHASE SPACE EFFECTS
      BRA1=0.5
      BRK0=0.5
      BRK0B=0.5
      BRKS=0.6667
      ENDIF
C     =====
      END








