      SUBROUTINE EVENTE(MODE,KEYYFS)
C ----------------------------------------------------------------------
C  MULTIPHOTON GENERATOR
C
C     called by : EVENTZ
C ----------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON / INOUT / INUT,IOUT
      COMMON / BEAMPM / ENE ,AMIN,AMFIN,IDE,IDF
      REAL*8            ENE ,AMIN,AMFIN
      COMMON / QEDPRM /ALFINV,ALFPI,XK0
      REAL*8           ALFINV,ALFPI,XK0
      COMMON / GAUSPM /SS,POLN,T3E,QE,T3F,QF
     &                ,XUPGI   ,XUPZI   ,XUPGF   ,XUPZF
     &                ,NDIAG0,NDIAGA,KEYA,KEYZ
     &                ,ITCE,JTCE,ITCF,JTCF,KOLOR
      REAL*8           SS,POLN,T3E,QE,T3F,QF
     &                ,XUPGI(2),XUPZI(2),XUPGF(2),XUPZF(2)
      COMMON / FINUS / CSTCM,ERREL
      REAL*8           CSTCM,ERREL
      COMMON / UTIL2 /  XK,C,S,CG,SG
      COMMON / UTIL3 / FIG,FI,IT,IBREM
      COMMON / UTIL8 / QP(4),QM(4),PH(4)
      REAL*8           QP   ,QM   ,PH
      COMMON / UTIL4 / AQP(4),AQM(4),APH(4)
      REAL*4           AQP   ,AQM   ,APH
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT
      COMMON / MOMINI / XF1(4),XF2(4),XPHUM(4),XPHOT(100,4),NPHOX
      COMMON / MOMSE4 / AQF1(4),AQF2(4),ASPHUM(4),ASPHOT(100,4),NPHOTA
      REAL*4            AQF1   ,AQF2   ,ASPHUM   ,ASPHOT
      COMMON / GSWPRM /SWSQ,AMW,AMZ,AMH,AMTOP,GAMMZ
      REAL*8           SWSQ,AMW,AMZ,AMH,AMTOP,GAMMZ
      COMMON / KEYSET / KEYGSW,KEYRAD,KEYTAB
      COMMON / VVREK  / VVMIN,VVMAX,VV,BETI
      REAL*8            VVMIN,VVMAX,VV,BETI
      DOUBLE PRECISION  WTMOD,WTCRU1,WTCRU2,WTSET     
      COMMON / WGTALL / WTMOD,WTCRU1,WTCRU2,WTSET(100)      
      DIMENSION  XPAR(30),NPAR(30)
      REAL*8 PPB(4),PMB(4)
      REAL*4 RRR(4)
      COMMON / KBREMS / KBRINI,KBRFIN,KBRINT
      DATA CMTR /389.385D-30/
      DATA NEXPAN /0/
C
C GENERATION OF THE PHOTON MOMENTUM XK AND DECISION ABOUT THE
C TYPE OF THE RADIATION  IT=1,2,3 CORRESPONDS TO INITIAL STATE
C RADIATION, FINAL STATE RADIATION AND SOFT PHOTON (XK.LT.XK0)
C RADIATION
C
C     INITIALIZATION IN EVENTE
      IF (MODE.EQ.-1) THEN
C       ====================
        CALL WMONIT(  -1,13,DUMM1,DUMM2,DUMM3)
        PI=4.D0*DATAN(1.D0)
        ALF1=ALFPI
        IF(KEYRAD.EQ.0.OR.KBRINI.EQ.0) THEN
          BETI=0D0
          DELI=0D0
        ELSE
          QE2=QE*QE
          BILG   = DLOG(4D0*ENE**2/AMIN**2)
          BETI=2D0*QE2*ALF1*(BILG-1D0)
          DELI=ALF1*QE2*(9D0*BILG+2D0*PI**2-12D0)/6D0
     $        +BETI*LOG(XK0)
        ENDIF
        IF(KEYRAD.EQ.0.OR.KBRFIN.EQ.0) THEN
          FACTOR=0D0
        ELSE
          FACTOR=1D0
          FACTOR=FACTOR*QF*QF
        ENDIF
C
C INITIALISE EXPAND
      IF (KEYRAD.GT.100) THEN
                  NPAR(1)=1000001
      ELSE
                  NPAR(1)=KEYYFS
      ENDIF
      KEYRED=0
              NPAR(2)=KEYRED
C KEYWGT=0 is standard choice. 1 weigted events (tests only) 
      KEYWGT=0
              NPAR(3)=KEYWGT
              NPAR(4)=KEYGSW
             XPAR(1)=2D0*ENE
             XPAR(2)=AMZ
             XPAR(3)=SWSQ
             XPAR(4)=GAMMZ
             XPAR(5)=AMFIN
             XPAR(6)=VVMIN
             XPAR(7)=VVMAX
        CALL EXPAND(-1,XPAR,NPAR)
C
      ELSEIF (MODE.EQ.0) THEN
C     =======================
    1   CONTINUE
        CALL RANMAR(RRR,4)
        CALL EXPAND( 0,XPAR,NPAR)
        IF (WTMOD.LE.1D-78) goto 1
C       ---------------------------------
C
C FILLING EXTRA COMMONS
        DO 39 I=1,4
        QP(I)=QF1(I)
        QM(I)=QF2(I)
        PH(I)=SPHUM(I)
        AQP(I)=QP(I)
        AQM(I)=QM(I)
 39     APH(I)=PH(I)
        WT=1D0
        WTMAX=1.0100D0
! ubic        IF(KEYGSW.GT.1) THEN
             WT =WAGA(0,0.0D0,0.D0)
             WT =WAGA(1,0.0D0,0.D0)/WT
             WTMAX=2D0
! ubic        ELSE
! ubic             WTDUMM=WAGA(0,0.D0,0.D0)
! ubic        ENDIF
        IF (KEYRAD.GT.100) WT=WT*(1D0+0.75*ALF1*QF**2)
        RN=RRR(1)
        CALL WMONIT(0,13,WT ,WTMAX,RN)
        IF(RN.GT.WT/WTMAX) GOTO 1
C
        IF (KEYRAD.EQ.11.OR.KEYRAD.GT.100) THEN
          CALL BDRESS(0,PPB,PMB,SVARX,CTHE)
        ELSE
          SVARX=5.0
          CTHE=0.0
        ENDIF  
        IF (KEYRAD.GT.100.AND.KBRFIN.NE.0) THEN
C         PHOTON ENERGY GENERATION - FINAL BREMSSTRAHLUNG
 333      XK=ALTPAR(SVARX,AMFIN,XK0,FACTOR)
          IF (XK.GT.1D0-4D0*AMFIN**2/SVARX) GO TO 333
        ELSE
          XK=0D0
        ENDIF
        IT=3
        IF (XK.GT.XK0) THEN
          IT=2
C HARD PHOTON CASE - FINAL STATE
C         PHOTON ANGULAR COORDINATES GENERATION
          CALL RRR6(XK,4D0*AMFIN**2/SVARX/(1D0-XK),CG,SG,IBREM)
C         FERMION ANGULAR COORDINATES
          C=CTHE
C         IF (ABS(CTHE).GE.1D0) PRINT *, 'DUZE CTHE',CTHE,'S=',SVARX
          IF (ABS(CTHE).GE.1D0) C=CTHE/ABS(CTHE)
          S=SQRT(1D0-C*C)
C         GENERATION OF THE ANGLE BETWEEN PHOTON-BEAM AND PHOTON-TAU PL
          RR2=RRR(2)
          FIG=-PI+2D0*PI*RR2
C
C         GENERATION OF THE ANGLE AROUND THE BEAM
          RR3=RRR(3)
          FI=-PI+2D0*PI*RR3
C         CALCULATION OF 4 MOMENTA FROM ANGULAR VARIABLES
          QP(4)=AMFIN
          PH(4)=SQRT(SVARX)
          QM(4)=AMFIN
          DO 103 I=1,3
          PH(I)=.0D0
          QP(I)=.0D0
  103     QM(I)=.0D0
          EBEAM=SQRT(SVARX)/2D0
          CALL TRASNG(1,EBEAM,AMFIN,AMIN,1,QP,QP)
          CALL TRASNG(1,EBEAM,AMFIN,AMIN,2,QM,QM)
          DO 304 I=1,4
  304     PH(I)=PH(I)-QP(I)-QM(I)
          CALL TRALOZ(0,-1,2D0*ENE    ,SPHUM,PPB,PMB,QP,QP)
          CALL TRALOZ(1,-1,2D0*ENE    ,SPHUM,PPB,PMB,QM,QM)
          CALL TRALOZ(1,-1,2D0*ENE    ,SPHUM,PPB,PMB,PH,PH)
          NPHOT=NPHOT+1
          DO 35 I=1,4
          SPHUM(I)=SPHUM(I)+PH(I)
          SPHOT(NPHOT,I)=PH(I)
          QF2(I)=QM(I)
  35      QF1(I)=QP(I)
        ELSEIF ( XK.LE.XK0) THEN
C         FERMION ANGULAR COORDINATES
          C=CTHE
        DO 49 I=1,4
        QP(I)=QF1(I)
        QM(I)=QF2(I)
 49     CONTINUE

          IF (ABS(CTHE).GE.1D0) C=CTHE/ABS(CTHE)
          S=SQRT(1D0-C*C)
C IN THE FOLLOWING WE WILL PERFORM TRANSFORMATION ON THE
C 4-MOMENTA GENERATED IN YFS-2 PROGRAM. THE PURPOSE IS TO HAVE
C 4-MOMENTA OF TAU PAIR TREATED EXACTLY THE SAME WAY AS DECAY
C PRODUCTS TO AVOID ROUNDING ERRORS.
          CALL TRALOZ(0, 1,2D0*ENE    ,SPHUM,PPB,PMB,QP,QP)
          FI =ANGXY(QP(2),QP(1))
          IF (QP(1).LT.0.D0) FI =-FI
C         CALCULATION OF 4 MOMENTA FROM ANGULAR VARIABLES
          QP(4)=AMFIN
          QM(4)=AMFIN
          DO 108 I=1,3
          QP(I)=.0D0
  108     QM(I)=.0D0
          EBEAM=SQRT(SVARX)/2D0
          CALL TRASNG(1,EBEAM,AMFIN,AMIN,1,QP,QP)
          CALL TRASNG(1,EBEAM,AMFIN,AMIN,2,QM,QM)
          CALL TRALOZ(1,-1,2D0*ENE    ,SPHUM,PPB,PMB,QP,QP)
          CALL TRALOZ(1,-1,2D0*ENE    ,SPHUM,PPB,PMB,QM,QM)
          DO 36 I=1,4
          QF2(I)=QM(I)
  36      QF1(I)=QP(I)
        ENDIF
C
C FILLING EXTRA COMMONS
        DO 30 I=1,4
        QP(I)=QF1(I)
        QM(I)=QF2(I)
        PH(I)=SPHUM(I)
        AQP(I)=QP(I)
        AQM(I)=QM(I)
 30     APH(I)=PH(I)
        NPHOTA=NPHOT
        DO 45 I=1,4
        AQF1(I)=QF1(I)
        AQF2(I)=QF2(I)
        ASPHUM(I)=SPHUM(I)
        DO 46 II=1,100
 46     ASPHOT(II,I)=SPHOT(II,I)
 45     CONTINUE
C
C for tests on bossting spinning with final state brem.
C if next line commented out no effect should be seen.
      IF (KEYRAD.GT.100) WTDUMM=WAGA(0,0.D0,0.D0)
      ELSEIF (MODE.EQ. 1) THEN
C     ========================
        IF (NEXPAN.EQ.0) THEN
          CALL EXPAND( 1,XPAR,NPAR)
          CALL EXPAND( 2,XPAR,NPAR)
          SIGT=XPAR(10)
          SIGT=XPAR(12)
          ERR=XPAR(11)
          NEXPAN=1
        ENDIF
        WRITE(IOUT,*) '=========================================='
        WRITE(IOUT,*) '========= WEIGHTS IN EVENTE =============='
        WRITE(IOUT,*) '=========================================='
        CALL WMONIT(2,13,AWT,DWT,WMX)
        CALL WMONIT(1,13,AWT,DWT,WMX)
        CSTOT=SIGT*AWT
        SIG0=4.D0*PI/ALFINV**2/3.D0/(4D0*ENE**2)
        CSTCM=SIGT*AWT*SIG0*CMTR
        ERREL=SQRT(DWT**2+ERR**2)
      ENDIF
C     =====
      END
