
      SUBROUTINE expand(mode,xkzpar,nkzpar)
*     ****************
      IMPLICIT DOUBLE PRECISION (a-h,o-z)
************************************************************************
* Local common blocks (it is not filled in M.C. generator any more!!!)
      DIMENSION pf1(4),pf2(4)
      DIMENSION xkzpar(30),nkzpar(30)
* All photons and fermions
      COMMON / momset / qf1(4),qf2(4),sphum(4),sphot(100,4),nphot
* ISR photons, note that xf1,xf2 are not filled
      COMMON / momini / xf1(4),xf2(4),xphum(4),xphot(100,4),nphox
      COMMON / MOMFIN / YF1(4),YF2(4),YPHUM(4),YPHOT(100,4),NPHOY      
* List of weights
      COMMON / wgtall / wtmod,wtcru1,wtcru2,wtset(100)
***********

*
      PARAMETER (nmxhep=2000) 
      COMMON/hepevtd/nevhep,nhep,isthep(nmxhep),idhep(nmxhep), 
     &jmohep(2,nmxhep),jdahep(2,nmxhep),phep(5,nmxhep),vhep(4,nmxhep) 
*
*
      COMMON / inout  / ninp,nout
      SAVE
      DIMENSION  xpar(1000),ypar(1000)
      DIMENSION  xdmem(100)

      IF (MODE.EQ.-1) THEN
!!!!!!!!!!!!!!!!!!!!!!!!!!
!#########################
!!!!!!!!!!!!!!!!!!!!!!!!!!
      WRITE(nout,*) '   '
      WRITE(nout,*) '=============================================='
      WRITE(nout,*) '========*********************************====='
      WRITE(nout,*) '========*** KORALZ-YFS3.40 interface  ***====='
      WRITE(nout,*) '========*********************************====='
      WRITE(nout,*) '=============================================='
      WRITE(nout,*) '   '

* DEFAULT data for MC generator
      do k=1,1000
       xpar(k)=0d0
      enddo
       xpar( 1)= 140.0                    ! cmsene
       xpar( 3)= 5.0                      ! ninp ??
       xpar( 4)= nout                     ! nout
       xpar( 5)= 1.0                      ! LevPri =xpar( 5)  !PrintOut Level 0,1,2,3
       xpar( 6)= 1.0                      ! Ie1Pri =xpar( 6)  !PrintOut Start point
       xpar( 7)= 2.0                      ! Ie2Pri =xpar( 7)  !PrintOut End   point
       xpar( 9)= 3.5                      ! wtmax
       xpar( 10)= 0.0                     ! KeyWgt
       xpar( 11)= 74.0                    ! 74.0 73.0 means third second order 
       xpar( 16)= 1.000000000000000E-06   ! vvmin
       xpar( 17)= 1.0                     ! vvmax
       xpar( 18)= 1.000000000000000E-03   ! delfac
       xpar( 20)= 1.0                     ! KeyIsr
       xpar( 21)= 1.0                     ! KeyFsr
       xpar( 22)= 0.0                     ! KeyPia
       xpar( 23)= 0.0                     ! MltISR Low-level multiphoton generator
       xpar( 24)= 0.0                     ! MltFSR Low-level multiphoton generator
       xpar( 25)= 0.0                     ! KeyFix
       xpar( 30)= 137.0359895             ! alfinv
       xpar( 31)= 389379.66               ! gnanob
       xpar( 32)= 1.166390000000000E-05   ! ??
       xpar( 50)= 1.0                     ! ??
       xpar( 51)= 0.0                     ! hadmin
       xpar( 52)= .118                    ! ??
       xpar( 400)= 11.0                   ! ??
       xpar( 413)= 13.0                   ! KFfin=xpar(400+i) i=1..20
       xpar( 501)= -2.0                   ! KeyZet
       xpar( 502)= 91.187                 ! amaz
       xpar( 503)= .23146                 ! sinw2
       xpar( 504)= 2.49                   ! gammz
       xpar( 511)= 1.0                    ! idf d-quark
       xpar( 512)= 3.0
       xpar( 513)= -1.0
       xpar( 514)= -1.0
       xpar( 516)= 1.000000000000000E-02
       xpar( 521)= 2.0                    ! idf u-quark
       xpar( 522)= 3.0
       xpar( 523)= 2.0
       xpar( 524)= 1.0
       xpar( 526)= 5.000000000000000E-03
       xpar( 531)= 3.0                    ! idf s-quark
       xpar( 532)= 3.0
       xpar( 533)= -1.0
       xpar( 534)= -1.0
       xpar( 536)= .2
       xpar( 541)= 4.0                    ! idf c-quark
       xpar( 542)= 3.0
       xpar( 543)= 2.0
       xpar( 544)= 1.0
       xpar( 546)= 1.3
       xpar( 551)= 5.0                    ! idf b-quark
       xpar( 552)= 3.0                    ! NCl
       xpar( 553)= -1.0                   ! 3*b-charge
       xpar( 554)= -1.0
       xpar( 556)= 4.2                    ! b-masss
        xpar( 561)= 6.0
       xpar( 562)= 3.0
       xpar( 563)= 2.0
       xpar( 564)= 1.0
       xpar( 566)= 180.0

       xpar( 611)= 11.0                   ! idf electron          
       xpar( 612)= 1.0                    ! NCf
       xpar( 613)= -3.0                   ! 3*qe qe=electric charge
       xpar( 614)= -1.0                   ! isospin, L-hand component
       xpar( 616)= 5.109990000000001E-04  ! amel=xpar(500+10*KFbeam+6)
       xpar( 621)= 12.0
       xpar( 622)= 1.0
       xpar( 624)= 1.0
       xpar( 626)= 9.999999999999998E-31
       xpar( 631)= 13.0                   ! idf muon
       xpar( 632)= 1.0                    ! NCf
       xpar( 633)= -3.0                   ! 3*q q=electric charge
       xpar( 634)= -1.0
       xpar( 636)= .1056583
       xpar( 641)= 14.0
       xpar( 642)= 1.0
       xpar( 644)= 1.0
       xpar( 646)= 9.999999999999998E-31
       xpar( 651)= 15.0
       xpar( 652)= 1.0
       xpar( 653)= -3.0
       xpar( 654)= -1.0
       xpar( 656)= 1.777
       xpar( 661)= 16.0
       xpar( 662)= 1.0
       xpar( 664)= 1.0
       xpar( 666)= 9.999999999999998E-31
*
* we over-write
      xpar(  1)=xkzpar(1)      
      xpar(  1)=xkzpar(1)      
      xpar(  1)=xkzpar(1)      
      xpar( 16)=xkzpar(6)      
      xpar( 17)=xkzpar(7)      
      xpar(502)=xkzpar(2)      
      xpar(503)=xkzpar(3)      
      xpar(504)=xkzpar(4)      
      xpar(636)=xkzpar(5) ! note this is always muon !!! flavors we do elsewhere      
      xpar( 20)=mod(nkzpar(1),10)     
      xpar( 21)=mod(nkzpar(1)/10,10)
      xpar( 10)=nkzpar(3)
      xpar(501)=nkzpar(4)
!      xpar( )=nkzpar(2) dummy by now !!!!
      CALL yfs3ff(-1,xpar,ypar)
!     ********************************
      CALL gbook1(  1,' memory  $',100 ,0d0,1d0)
!-------------------------------------------------------!
!                 main MC loop                          !
!-------------------------------------------------------!
      iev=0
      elseIF (MODE.EQ.0) THEN
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!############################
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
          iev=iev+1
!         *************************
          CALL yfs3ff( 0,xpar,ypar)
!         *************************
*---------------------------------------------------------------
* Fill-in /momset/ /momfin/ and /momini/ for KORALZ
          DO k=1,4
             pf1(k) =phep(k,1)
             pf2(k) =phep(k,2)
             qf1(k) =phep(k,3)
             qf2(k) =phep(k,4)
             sphum(k)=0d0
             xphum(k)=0d0
             yphum(k)=0d0
          ENDDO
          KFfin = idhep(3)
*     and photons
          nphot=0
          nphox=0
          nphoy=0
          DO j=1,100
             ih = 4+j
             kf = idhep(ih)
*     stop if /hepevt/ ended or non-photon found
             IF(ih .GT. nhep) GOTO 110
             IF(kf .NE. 22)   GOTO 110
*     All photons here
             nphot=nphot+1
             DO  k=1,4
                sphot(nphot,k) =phep(k,ih)
                sphum(k) =sphum(k)+sphot(nphot,k)
             ENDDO
*     ISR photons separately
             IF(jmohep(1,ih) .EQ. 1) THEN
                nphox=nphox+1
                DO  k=1,4
                   xphot(nphox,k) =phep(k,ih)
                   xphum(k) =xphum(k)+xphot(nphox,k)
                ENDDO
             ELSE
*     FSR photons separately
                nphoy=nphoy+1
                DO  k=1,4
                   yphot(nphoy,k) =phep(k,ih)
                   yphum(k) =yphum(k)+yphot(nphoy,k)
                ENDDO

             ENDIF
          ENDDO
 110      CONTINUE
*---------------------------------------------------------------
* list of the weights
         DO j=1,100
            wtset(j)=ypar(100+j)
         ENDDO
         wtmod  =ypar(201)
         wtcrud =ypar(202)
         wtcru1 =ypar(203)
         wtcru2 =ypar(204)
*---------------------------------------------------------------
*   Control printout
          CALL momprt(' YFSPRO  ',
     $         6,iev,1,1,pf1,pf2,qf1,qf2,nphot,sphot,KFfin)

*          CALL momprt('*YFSPRO* ',
*     $        16,iev,1,1,pf1,pf2,qf1,qf2,nphot,sphot,KFfin)
*
          CALL dumpri('*momini*',
     $         6,iev,1,1,xf1,xf2,nphox,xphot)
          CALL dumpri('*momfin*',
     $         6,iev,1,1,xf1,xf2,nphoy,yphot)
*
*          CALL dumpri('*momini*',
*     $        16,iev,1,10,xf1,xf2,nphox,xphot)


      ELSE
!!!!!!!!!!
!#########
!!!!!!!!!!

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
      WRITE(6,*) ' generation finished '
      CALL yfs3ff( 2,xpar,ypar)
*------------------------------------------------
*
      xkzpar(10)=ypar(22)    ! sig [R]
      xkzpar(12)=ypar(22)    ! sig [R]
      xkzpar(11)=ypar(21)    ! errel
      write(*,*) 'ypar(20-22)=',ypar(20),ypar(21),ypar(22)
      ENDIF
!!!!!!!!!!!
!##########
!!!!!!!!!!!
      END



****************************************************************
*
*  Output of YFS3ff is encoded in double precission /hepevtd/
*  which is double precision version of /hepevt/
*  It was necessary to rename /hepevt/
*  because Jetset uses REAL*4 version of /hepevt/
*
*  We introduce luhepc->luhepcd which is
*  Double Precision version of luhepc. It translates
*  from /hepevtd/ to (from) Jetset-common-blocks
*
****************************************************************


      SUBROUTINE tohepyfs(xpar,ypar,
     $     pf1,pf2,qf1,qf2,xphot,nphox,yphot,nphoy)
*     **********************************************************
* INPUT:
*     pf1,pf2,amel   beam (electron) momenta and masses
*     qf1,qf2,amfin  final momenta and masses
*     nphot          photon multiplicity
*     sphot          photon momenta
*     **********************************************************
      IMPLICIT DOUBLE PRECISION (a-h,o-z)
* Filling HEP COMMON block using filhep routine
      DIMENSION xpar(*),ypar(*)
      DIMENSION pf1(4),pf2(4),qf1(4),qf2(4),xphot(100,4),yphot(100,4)
      DIMENSION aph(5)

      KFbeam = 11           ! KF=11 is electron
      ke = 500+10*KFbeam
      amel   = xpar(ke+6)
      KFfin =ypar(400)
      kf = 500+10*KFfin
      amfin  = xpar(kf+6)
* Beams
      CALL filhepyfs(1,3, 11, 0,0,0,0, pf1,amel,.FALSE.)
      CALL filhepyfs(2,3,-11, 0,0,0,0, pf2,amel,.FALSE.)
* Final state fermions
      KStat = 1
      CALL filhepyfs(3,KStat, KFfin, 1,2,0,0, qf1,amfin,.FALSE.)
      CALL filhepyfs(4,KStat,-KFfin, 1,2,0,0, qf2,amfin,.FALSE.)
* Radiative photons (5 ... 4+nphot) (pdg-code for gamma is 22)
      ip=0
      IF(nphox .NE. 0) THEN
         DO i=1,nphox
            DO j=1,4
               aph(j)=xphot(i,j)
            END DO
            ip=ip+1
            CALL filhepyfs(4+ip,1,22, 1,2,0,0, aph,0d0,.FALSE.)
         END DO
      END IF
      IF(nphoy .NE. 0) THEN
         DO i=1,nphoy
            DO j=1,4
               aph(j)=yphot(i,j)
            END DO
            ip=ip+1
            CALL filhepyfs(4+ip,1,22, 3,4,0,0, aph,0d0,.FALSE.)
         END DO
      END IF

      END

      SUBROUTINE tohadyfs(xpar,ypar)
*     ***************************
* Aranging jets and hadronization
      IMPLICIT DOUBLE PRECISION (a-h,o-z)
      DOUBLE PRECISION xpar(*),ypar(*)
* ----------------------------------------------------------------------
      PARAMETER (nmxhep=2000)
      COMMON /hepevtd/
     $     nevhep,nhep,isthep(nmxhep),idhep(nmxhep),
     $     jmohep(2,nmxhep),jdahep(2,nmxhep),phep(5,nmxhep),
     $     vhep(4,nmxhep)
* ----------------------------------------------------------------------
      INTEGER ijoin(2)
      REAL*4 sqrs1
      
      END
      SUBROUTINE filhepyfs(n,ist,id,jmo1,jmo2,jda1,jda2,p4,pinv,phflag)
* ----------------------------------------------------------------------
* This subroutine fills one entry into the hepevt common
* and updates the information for affected mother entries
* WRITTEN by Martin W. Gruenewald (91/01/28)
* Re-Edited by S. Jadach, 6 july 97
      IMPLICIT DOUBLE PRECISION (a-h,o-z)
      DOUBLE PRECISION p4(4),pinv
      LOGICAL phflag
* ----------------------------------------------------------------------
      PARAMETER (nmxhep=2000)
      COMMON /hepevtd/
     $     nevhep,nhep,isthep(nmxhep),idhep(nmxhep),
     $     jmohep(2,nmxhep),jdahep(2,nmxhep),phep(5,nmxhep),
     $     vhep(4,nmxhep)
* ----------------------------------------------------------------------
      COMMON /phoqed/ qedrad(nmxhep)
      LOGICAL qedrad
* ----------------------------------------------------------------------
      SAVE
*
* check address mode
      IF (n .EQ. 0) THEN
* append mode
        ihep=nhep+1
      ELSE IF (n .GT. 0) THEN
* absolute position
        ihep=n
      ELSE
* relative position
        ihep=nhep+n
      END IF
*
* check on ihep
      IF ((ihep .LE. 0) .OR. (ihep .GT. nmxhep)) RETURN
*
* add entry
      nhep=ihep
      isthep(ihep)   =ist
      idhep(ihep)    =id
      jmohep(1,ihep) =jmo1
      IF(jmo1 .LT. 0)  jmohep(1,ihep)=jmohep(1,ihep)+ihep
      jmohep(2,ihep) =jmo2
      IF(jmo2 .LT. 0)  jmohep(2,ihep)=jmohep(2,ihep)+ihep
      jdahep(1,ihep) =jda1
      jdahep(2,ihep) =jda2
*
      DO i=1,4
         phep(i,ihep)=p4(i)
* KORAL-B and KORAL-Z do not provide vertex and/or lifetime informations
         vhep(i,ihep)=0d0
      END DO
      phep(5,ihep)=pinv
* flag for photos...
      qedrad(ihep)=phflag
* update process:
      DO ip=jmohep(1,ihep),jmohep(2,ihep)
         IF(ip .GT. 0)THEN
* IF there is a daughter at ihep, mother entry at ip has decayed
            IF(isthep(ip) .EQ. 1)isthep(ip)=2
* and daughter pointers of mother entry must be updated
            IF(jdahep(1,ip) .EQ. 0)THEN
               jdahep(1,ip)=ihep
               jdahep(2,ip)=ihep
            ELSE
               jdahep(2,ip)=max(ihep,jdahep(2,ip))
            END IF
         END IF
      END DO
*
      END
      SUBROUTINE DUMPS(NOUT)                 
C     **********************                 
C THIS PRINTS OUT FOUR MOMENTA OF PHOTONS    
C ON UNIT NO. NOUT                           
C     **********************                 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)    
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT  
      SAVE   / MOMSET /
      DIMENSION SUM(4)                       
      WRITE(NOUT,*) '=====================DUMPS===================='
      WRITE(NOUT,3100) 'QF1',(  QF1(  K),K=1,4) 
      WRITE(NOUT,3100) 'QF2',(  QF2(  K),K=1,4) 
      DO 100 I=1,NPHOT                       
  100 WRITE(NOUT,3100) 'PHO',(SPHOT(I,K),K=1,4) 
      DO 200 K=1,4                           
  200 SUM(K)=QF1(K)+QF2(K)                   
      DO 210 I=1,NPHOT                       
      DO 210 K=1,4                           
  210 SUM(K)=SUM(K)+SPHOT(I,K)               
      WRITE(NOUT,3100) 'SUM',(  SUM(  K),K=1,4) 
 3100 FORMAT(1X,A3,1X,5F18.14)               
      END                                    



      SUBROUTINE WMONIT(MODE,ID,WT,WTMAX,RN)
C     **************************************
C last correction 19 sept. 89
C Utility program for monitoring M.C. rejection weights.
C ID is weight idendifier, maximum IDMX (defined below).
C WT IS WEIGHT, WTMAX IS MAXIMUM WEIGHT AND RN IS RANDOM NUMBER.
C IF(MODE.EQ.-1) THEN
C          INITALIZATION IF ENTRY ID, OTHER ARGUMENTS ARE IGNORED
C ELSEIF(MODE.EQ.0) THEN
C          SUMMING UP WEIGHTS ETC. FOR A GIVEN EVENT FOR ENTRY ID
C        - WT IS CURRENT WEIGHT.
C        - WTMAX IS MAXIMUM WEIGHT USED FOR COUTING OVERWEIGHTED
C          EVENTS WITH WT>WTMAX.
C        - RN IS RANDOM NUMBER USED IN REJECTION, IT IS USED TO
C          COUNT NO. OF ACCEPTED (RN<WT/WTMAX) AND REJECTED
C          (WT>WT/WTMAX) EVENTS,
C          IF RO REJECTION THEN PUT RN=0D0.
C ELSEIF(MODE.EQ.1) THEN
C          IN THIS MODE WMONIT REPPORTS ON ACCUMULATED STATISTICS
C          AND THE INFORMATION IS STORED IN COMMON /CMONIT/
C        - AVERWT= AVERAGE WEIGHT WT COUNTING ALL EVENT
C        - ERRELA= RELATIVE ERROR OF AVERWT
C        - NEVTOT= TOTAL NIMBER OF ACCOUNTED EVENTS
C        - NEVACC= NO. OF ACCEPTED EVENTS (RN<WT\WTMAX)
C        - NEVNEG= NO. OF EVENTS WITH NEGATIVE WEIGHT (WT<0)
C        - NEVZER= NO. OF EVENTS WITH ZERO WEIGHT (WT.EQ.0D0)
C        - NEVOVE= NO. OF OVERWEGHTED EVENTS (WT>WTMAX)
C          AND IF YOU DO NOT WANT TO USE CMONIT THEN THE VALUE
C          The value of AVERWT is assigned to WT,
C          the value of ERRELA is assigned to WTMAX and
C          the value of WTMAX  is assigned to RN in this mode.
C ELSEIF(MODEE.EQ.2) THEN
C          ALL INFORMATION DEFINED FOR ENTRY ID DEFINED ABOVE
C          FOR MODE=2 IS JUST PRINTED OF UNIT NOUT
C ENDIF
C NOTE THAT OUTPUT REPPORT (MODE=1,2) IS DONE DYNAMICALLY JUST FOR A
C GIVEN ENTRY ID ONLY AND IT MAY BE REPEATED MANY TIMES FOR ONE ID AND
C FOR VARIOUS ID'S AS WELL.
C     ************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      save
      PARAMETER(IDMX=100)
      COMMON / CMONIT/ AVERWT,ERRELA,NEVTOT,NEVACC,NEVNEG,NEVOVE,NEVZER
      COMMON / INOUT  / NINP,NOUT
      INTEGER NTOT(IDMX),NACC(IDMX),NNEG(IDMX),NOVE(IDMX),NZER(IDMX)
      DIMENSION SWT(IDMX),SSWT(IDMX),WWMX(IDMX)
      DATA NTOT /IDMX* -1/  SWT /IDMX*   0D0/
      DATA SSWT /IDMX*0D0/ WWMX /IDMX*-1D-20/
C
      IF(ID.LE.0.OR.ID.GT.IDMX) THEN
           WRITE(NOUT,*) ' =====WMONIT: WRONG ID',ID
           STOP
      ENDIF
      IF(MODE.EQ.-1) THEN
           NTOT(ID)=0
           NACC(ID)=0
           NNEG(ID)=0
           NZER(ID)=0
           NOVE(ID)=0
           SWT(ID)   =0D0
           SSWT(ID)  =0D0
           WWMX(ID)  = -1D-20
      ELSEIF(MODE.EQ.0) THEN
           IF(NTOT(ID).LT.0) THEN
              WRITE(NOUT,*) ' ==== WARNING FROM WMONIT: '
              WRITE(NOUT,*) ' LACK OF INITIALIZATION, ID=',ID
           ENDIF
           NTOT(ID)=NTOT(ID)+1
           SWT(ID)=SWT(ID)+WT
           SSWT(ID)=SSWT(ID)+WT**2
           WWMX(ID)= MAX(WWMX(ID),WT)
           IF(WT.EQ.0D0)   NZER(ID)=NZER(ID)+1
           IF(WT.LT.0D0)   NNEG(ID)=NNEG(ID)+1
           IF(WT.GT.WTMAX)      NOVE(ID)=NOVE(ID)+1
           IF(RN*WTMAX.LE.WT)   NACC(ID)=NACC(ID)+1
      ELSEIF(MODE.EQ.1) THEN
           IF(NTOT(ID).LT.0) THEN
              WRITE(NOUT,*) ' ==== WARNING FROM WMONIT: '
              WRITE(NOUT,*) ' LACK OF INITIALIZATION, ID=',ID
           ENDIF
           IF(NTOT(ID).LE.0.OR.SWT(ID).EQ.0D0)  THEN
              AVERWT=0D0
              ERRELA=0D0
           ELSE
              AVERWT=SWT(ID)/FLOAT(NTOT(ID))
              ERRELA=SQRT(ABS(SSWT(ID)/SWT(ID)**2-1D0/FLOAT(NTOT(ID))))
           ENDIF
           NEVTOT=NTOT(ID)
           NEVACC=NACC(ID)
           NEVNEG=NNEG(ID)
           NEVZER=NZER(ID)
           NEVOVE=NOVE(ID)
           WT=AVERWT
           WTMAX=ERRELA
           RN    =WWMX(ID)
      ELSEIF(MODE.EQ.2) THEN
           IF(NTOT(ID).LE.0.OR.SWT(ID).EQ.0D0)  THEN
              AVERWT=0D0
              ERRELA=0D0
           ELSE
              AVERWT=SWT(ID)/FLOAT(NTOT(ID))
              ERRELA=SQRT(ABS(SSWT(ID)/SWT(ID)**2-1D0/FLOAT(NTOT(ID))))
              WWMAX=WWMX(ID)
           ENDIF
           WRITE(NOUT,1003) ID, AVERWT, ERRELA, WWMAX
           WRITE(NOUT,1004) NTOT(ID),NACC(ID),NNEG(ID),NOVE(ID),NZER(ID)
           WT=AVERWT
           WTMAX=ERRELA
           RN    =WWMX(ID)
      ELSE
           WRITE(NOUT,*) ' =====WMONIT: WRONG MODE',MODE
           STOP
      ENDIF
 1003 FORMAT(
     $  ' =======================WMONIT========================'
     $/,'   ID           AVERWT         ERRELA            WWMAX'
     $/,    I5,           E17.7,         F15.9,           E17.7)
 1004 FORMAT(
     $  ' -----------------------------------------------------------'
     $/,'      NEVTOT      NEVACC      NEVNEG      NEVOVE      NEVZER'
     $/,   5I12)
      END

      SUBROUTINE WMONI2(MODE,ID,WT,WTMAX,RN)
C     **************************************
C -------------- SECOND COPY OF WMONIT ----------------
C last correction 19 sept. 89
C Utility program for monitoring M.C. rejection weights.
C ID is weight idendifier, maximum IDMX (defined below).
C WT IS WEIGHT, WTMAX IS MAXIMUM WEIGHT AND RN IS RANDOM NUMBER.
C IF(MODE.EQ.-1) THEN
C          INITALIZATION IF ENTRY ID, OTHER ARGUMENTS ARE IGNORED
C ELSEIF(MODE.EQ.0) THEN
C          SUMMING UP WEIGHTS ETC. FOR A GIVEN EVENT FOR ENTRY ID
C        - WT IS CURRENT WEIGHT.
C        - WTMAX IS MAXIMUM WEIGHT USED FOR COUTING OVERWEIGHTED
C          EVENTS WITH WT>WTMAX.
C        - RN IS RANDOM NUMBER USED IN REJECTION, IT IS USED TO
C          COUNT NO. OF ACCEPTED (RN<WT/WTMAX) AND REJECTED
C          (WT>WT/WTMAX) EVENTS,
C          IF RO REJECTION THEN PUT RN=0D0.
C ELSEIF(MODE.EQ.1) THEN
C          IN THIS MODE WMONIT REPPORTS ON ACCUMULATED STATISTICS
C          AND THE INFORMATION IS STORED IN COMMON /CMONIT/
C        - AVERWT= AVERAGE WEIGHT WT COUNTING ALL EVENT
C        - ERRELA= RELATIVE ERROR OF AVERWT
C        - NEVTOT= TOTAL NIMBER OF ACCOUNTED EVENTS
C        - NEVACC= NO. OF ACCEPTED EVENTS (RN<WT\WTMAX)
C        - NEVNEG= NO. OF EVENTS WITH NEGATIVE WEIGHT (WT<0)
C        - NEVZER= NO. OF EVENTS WITH ZERO WEIGHT (WT.EQ.0D0)
C        - NEVOVE= NO. OF OVERWEGHTED EVENTS (WT>WTMAX)
C          AND IF YOU DO NOT WANT TO USE CMONIT THEN THE VALUE
C          The value of AVERWT is assigned to WT,
C          the value of ERRELA is assigned to WTMAX and
C          the value of WTMAX  is assigned to RN in this mode.
C ELSEIF(MODEE.EQ.2) THEN
C          ALL INFORMATION DEFINED FOR ENTRY ID DEFINED ABOVE
C          FOR MODE=2 IS JUST PRINTED OF UNIT NOUT
C ENDIF
C NOTE THAT OUTPUT REPPORT (MODE=1,2) IS DONE DYNAMICALLY JUST FOR A
C GIVEN ENTRY ID ONLY AND IT MAY BE REPEATED MANY TIMES FOR ONE ID AND
C FOR VARIOUS ID'S AS WELL.
C     ************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      save
      PARAMETER(IDMX=100)
      COMMON / CMONI2/ AVERWT,ERRELA,NEVTOT,NEVACC,NEVNEG,NEVOVE,NEVZER
      COMMON / INOUT  / NINP,NOUT
      INTEGER NTOT(IDMX),NACC(IDMX),NNEG(IDMX),NOVE(IDMX),NZER(IDMX)
      DIMENSION SWT(IDMX),SSWT(IDMX),WWMX(IDMX)
      DATA NTOT /IDMX* -1/  SWT /IDMX*   0D0/
      DATA SSWT /IDMX*0D0/ WWMX /IDMX*-1D-20/
C
      IF(ID.LE.0.OR.ID.GT.IDMX) THEN
           WRITE(NOUT,*) ' =====WMONI2: WRONG ID',ID
           STOP
      ENDIF
      IF(MODE.EQ.-1) THEN
           NTOT(ID)=0
           NACC(ID)=0
           NNEG(ID)=0
           NZER(ID)=0
           NOVE(ID)=0
           SWT(ID)   =0D0
           SSWT(ID)  =0D0
           WWMX(ID)  = -1D-20
      ELSEIF(MODE.EQ.0) THEN
           IF(NTOT(ID).LT.0) THEN
              WRITE(NOUT,*) ' ==== WARNING FROM WMONIT: '
              WRITE(NOUT,*) ' LACK OF INITIALIZATION, ID=',ID
           ENDIF
           NTOT(ID)=NTOT(ID)+1
           SWT(ID)=SWT(ID)+WT
           SSWT(ID)=SSWT(ID)+WT**2
           WWMX(ID)= MAX(WWMX(ID),WT)
           IF(WT.EQ.0D0)   NZER(ID)=NZER(ID)+1
           IF(WT.LT.0D0)   NNEG(ID)=NNEG(ID)+1
           IF(WT.GT.WTMAX)      NOVE(ID)=NOVE(ID)+1
           IF(RN*WTMAX.LE.WT)   NACC(ID)=NACC(ID)+1
      ELSEIF(MODE.EQ.1) THEN
           IF(NTOT(ID).LT.0) THEN
              WRITE(NOUT,*) ' ==== WARNING FROM WMONI2: '
              WRITE(NOUT,*) ' LACK OF INITIALIZATION, ID=',ID
           ENDIF
           IF(NTOT(ID).LE.0.OR.SWT(ID).EQ.0D0)  THEN
              AVERWT=0D0
              ERRELA=0D0
           ELSE
              AVERWT=SWT(ID)/FLOAT(NTOT(ID))
              ERRELA=SQRT(ABS(SSWT(ID)/SWT(ID)**2-1D0/FLOAT(NTOT(ID))))
           ENDIF
           NEVTOT=NTOT(ID)
           NEVACC=NACC(ID)
           NEVNEG=NNEG(ID)
           NEVZER=NZER(ID)
           NEVOVE=NOVE(ID)
           WT=AVERWT
           WTMAX=ERRELA
           RN    =WWMX(ID)
      ELSEIF(MODE.EQ.2) THEN
           IF(NTOT(ID).LE.0.OR.SWT(ID).EQ.0D0)  THEN
              AVERWT=0D0
              ERRELA=0D0
           ELSE
              AVERWT=SWT(ID)/FLOAT(NTOT(ID))
              ERRELA=SQRT(ABS(SSWT(ID)/SWT(ID)**2-1D0/FLOAT(NTOT(ID))))
              WWMAX=WWMX(ID)
           ENDIF
           WRITE(NOUT,1003) ID, AVERWT, ERRELA, WWMAX
           WRITE(NOUT,1004) NTOT(ID),NACC(ID),NNEG(ID),NOVE(ID),NZER(ID)
           WT=AVERWT
           WTMAX=ERRELA
           RN    =WWMX(ID)
      ELSE
           WRITE(NOUT,*) ' =====WMONI2: WRONG MODE',MODE
           STOP
      ENDIF
 1003 FORMAT(
     $  ' =======================WMONI2========================'
     $/,'   ID           AVERWT         ERRELA            WWMAX'
     $/,    I5,           E17.7,         F15.9,           E17.7)
 1004 FORMAT(
     $  ' -----------------------------------------------------------'
     $/,'      NEVTOT      NEVACC      NEVNEG      NEVOVE      NEVZER'
     $/,   5I12)
      END
