C   February 93   
C Warning! the first 3 parameters in XPAR has changed!!!
C CMSENE is not input parameter anymore!!!
C Initialization of GLIBK mooved to generator

C =============================================='
C ==========*********************==============='
C ==========***  Y F S P R O  ***==============='
C ==========*********************==============='
C =============================================='
C Monte Carlo PRODUCTION program which together with YFSFIG
C graphical program embodies benchmarks and test of YFS3.
C
      PROGRAM  MAIN       
C     *************       
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / INOUT  / NINP,NOUT     
        
      NINP= 5    
      NOUT=16    
      OPEN(NOUT,file="pro.output")
C     ********** 
      CALL SPLOT 
C     ********** 
C ------------WRITING HISTOS ON THE DISK ------------------------      
      NOUTH=10   
      OPEN(NOUTH,file="pro.hst")
      CALL GRFILE(NOUTH,DNAME,'N') 
      CALL GROUT( 0,ICY,' ')       
      CALL GREND(DNAME)   
C ------------THE END OF HISTO WRITING -------------------------       
      CLOSE(NOUT)         
      END        

      LOGICAL FUNCTION KONIEC(IEV,NEVLIM,LIMTIM)    
C     ******************************************    
      TLIMIT=LIMTIM    
C THIS IS SLAC TIMER   
CCC   CALL LEFT1A(TIMLFT)        
C THIS IS CERN TIMER   
cccccc      CALL TIMEL(TIMLFT)
      TIMLFT = 1E15
      KONIEC = (IEV.GE.NEVLIM).OR.(TIMLFT.LT.TLIMIT)         
      END     
    
      SUBROUTINE SPLOT 
C     **************** 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT      
      COMMON / INPARM / CMSENE,AMFIN,KEYRAD        
      COMMON / INOUT  / NINP,NOUT   
      SAVE / MOMSET /,/ INPARM /,/ INOUT  /
      DIMENSION  XPAR(100),NPAR(100),XDMEM(100)        
      CHARACTER*80 TESTIT
      LOGICAL KONIEC   

      LIMTIM= 20       
      WRITE(NOUT,*) '   '
      WRITE(NOUT,*) '=============================================='
      WRITE(NOUT,*) '==========*********************==============='
      WRITE(NOUT,*) '==========***  Y F S P R O  ***==============='
      WRITE(NOUT,*) '==========*********************==============='
      WRITE(NOUT,*) '=============================================='
      WRITE(NOUT,*) '   '
 3000 FORMAT(A80)
 3001 FORMAT(8I2)
 3002 FORMAT(I10)      
 3003 FORMAT(F10.0)    
ccc      WRITE( 6,*) ' TYPE NEVT '  
ccc      READ(  5,*)          NEVT       
      READ( NINP,3002)  NEVT
      WRITE( 6,*)     NEVT,' REQUESTED EVENTS '
      WRITE(NOUT,*)   NEVT,' REQUESTED EVENTS '
      READ( NINP,3000) TESTIT
      WRITE(NOUT,3000) TESTIT
      READ(NINP,3001) KAT1,KAT2,KAT3,KAT4,KAT5,KAT6,KAT7,KAT8
      READ(NINP,3002) KEYRAD     
      READ(NINP,3003) CMSENE,SINW2,AMAZ,GAMMZ       
      READ(NINP,3003) AMFIN,VVMIN,VVMAX   
      READ(NINP,3002) KEYRED,KEYWGT,KEYGSW          
C======================================
C Control output
      WRITE(NOUT,'(8A6/8I6)')
     $ 'KAT1','KAT2','KAT3','KAT4','KAT5','KAT6','KAT7','KAT8',
     $  KAT1 , KAT2 , KAT3 , KAT4 , KAT5 , KAT6 , KAT7 , KAT8
      WRITE(NOUT,'(4A12/4I12)')
     $  'NEVT','KEYRAD','KEYWGT','KEYGWS',
     $   NEVT,  KEYRAD , KEYWGT , KEYGWS
      WRITE(NOUT,'(6A12/6F12.6)')
     $ 'CMSENE','SINW2','AMAZ','GAMMZ','VVMIN','VVMIN',
     $  CMSENE , SINW2 , AMAZ , GAMMZ , VVMIN , VVMIN
      NPAR(1)=KEYRAD   
      NPAR(2)=KEYRED   
      NPAR(3)=KEYWGT   
      NPAR(4)=KEYGSW   
      XPAR(1)=CMSENE   
      XPAR(2)=AMAZ     
      XPAR(3)=SINW2    
      XPAR(4)=GAMMZ    
      XPAR(5)=AMFIN    
      XPAR(6)=VVMIN    
      XPAR(7)=VVMAX    
      CALL EXPAND(-1,XPAR,NPAR)    
C     ********************************    
      CALL GBOOK1(  1,' Memory  $',100 ,0D0,1D0)   
      IF(KAT1.EQ.1) CALL ROBOL1(-1)       
      IF(KAT2.EQ.1) CALL ROBOL2(-1)       
      IF(KAT3.EQ.1) CALL ROBOL3(-1)       
      IF(KAT4.EQ.1) CALL ROBOL4(-1)       
      IF(KAT5.EQ.1) CALL ROBOL5(-1)       
C----------- TIME AND EVENT LIMITS FOR THE MAIN LOOP ----------------- 
      IEV=0   
C----------------------------------------------------------------------
      DO 100 IJK=1,10000000      
      IEV=IEV+1        
      IF(MOD(IEV,5000).EQ.1) WRITE(6,*) '  IEV= ',IEV        
      CALL EXPAND( 0,XPAR,NPAR)    
C     ********************************    
      IF(IEV.LE.10) CALL DUMPN(6,IEV)         
      IF(IEV.LE.10) CALL DUMPI(NOUT)      
      IF(IEV.LE.10) CALL DUMPF(NOUT)      
      IF(IEV.LE.20) CALL DUMPN(NOUT,IEV)      
      IF(KONIEC(IEV,NEVT,LIMTIM)) CALL DUMPN(NOUT,IEV)      
ccc      IF(IEV.LE. 5) CALL DUMPBT(NOUT)     
      IF(KAT1.EQ.1) CALL ROBOL1( 0)       
      IF(KAT2.EQ.1) CALL ROBOL2( 0)       
      IF(KAT3.EQ.1) CALL ROBOL3( 0)       
      IF(KAT4.EQ.1) CALL ROBOL4( 0)       
      IF(KAT5.EQ.1) CALL ROBOL5( 0)       
C------------------- EXIT FROM THE MAIN LOOP --------------------------
      IF(KONIEC(IEV,NEVT,LIMTIM)) GOTO 103          
  100 CONTINUE         
  103 CONTINUE         
C-----------------------------------------------------------------------
      write(6,*) ' generation finished '
      CALL EXPAND( 2,XPAR,NPAR)    
      NEVT   = NPAR(10)   
      XSECNB = XPAR(20)   
      ERREL  = XPAR(21)   
      XSECR  = XPAR(22)   
      WTAVR=XPAR(10)/XPAR(20)    
C------------------------------------------------
C Store usefull information in first histo ID=1
      DO 500 K=1,100
 500  XDMEM(K)=0D0
      XDMEM(10) = NEVT
      XDMEM(20) = XSECNB
      XDMEM(21) = ERREL
      XDMEM(22) = XSECR
      XDMEM(23) = WTAVR
      XDMEM(30) = CMSENE
      CALL GPAK(1,XDMEM)
C------------------------------------------------
      IF(KAT1.EQ.1) CALL ROBOL1(1)        
      IF(KAT2.EQ.1) CALL ROBOL2(1)        
      IF(KAT3.EQ.1) CALL ROBOL3(1)        
      IF(KAT4.EQ.1) CALL ROBOL4(1)        
      IF(KAT5.EQ.1) CALL ROBOL5(1)        
      END     

      SUBROUTINE ROBOL1(MODE)    
C     ***********************    
C          ===================================
C          ============ ROBOL1 ===============
C          ===================================
C Initial state study of v=1-s'/s distribution
C v*rho(v) distribution as a function of log(v)
C total MC result and beta contributions in O(alf0,1,2)
C     ***********************************      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      COMMON / INOUT  / NINP,NOUT   
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT      
      COMMON / INPARM / CMSENE,AMFIN,KEYRAD        
      COMMON / WGTALL / WTMOD,WTCRU1,WTCRU2,WTSET(100)       
      SAVE / INOUT  /,/ MOMSET /,/ INPARM /,/ WGTALL /
      SAVE TMAX,TMIN,NBT,IDA,IDB
C    
      IF(MODE.EQ.-1) THEN        
C     ===================        
      TMAX = 0.0       
      TMIN = -4.0      
      NBT  = 80        
      IDA  = 10000
      CALL GBOOK1(IDA+300,'v*rho(v) O(alf0)         $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+301,'v*rho(v) O(alf1)         $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+302,'v*rho(v) O(alf2)         $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+305,'v*rho(v) O(alf1)-O(alf0) $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+306,'v*rho(v) O(alf2)-O(alf1) $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+310,'v*rho(v)  beta0  O(alf1) $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+311,'v*rho(v)  beta1  O(alf1) $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+320,'v*rho(v)  beta0  O(alf2) $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+321,'v*rho(v)  beta1  O(alf2) $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+322,'v*rho(v)  beat2  O(alf2) $',NBT,TMIN,TMAX)
      NBV = 50
      VMIN= 0
      VMAX= 1
      IDB  = 50000
      CALL GBOOK1(IDB+300,'rho(V) ini O(0)        $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+301,'rho(V) ini O(1)        $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+302,'rho(V) ini O(2)        $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+305,'rho(V) ini O(1-0)      $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+306,'rho(V) ini O(2-1)      $',NBV,VMIN,VMAX)

      ELSEIF(MODE.EQ.0) THEN     
C     ======================     
      WTCRUD =WTCRU1*WTCRU2      
      WT1  = WTCRUD*WTSET(71)    
      WT2  = WTCRUD*WTSET(72)    
      WT3  = WTCRUD*WTSET(73)    
      WT10 = WTCRUD*WTSET(80)    
      WT11 = WTCRUD*WTSET(81)    
      WT20 = WTCRUD*WTSET(90)    
      WT21 = WTCRUD*WTSET(91)    
      WT22 = WTCRUD*WTSET(92)    
      WT=WTMOD
      VV = 0D0
      T10= -100000000.   
      IF(NPHOT.NE.0) THEN        
         S1=   (QF1(4)+QF2(4))**2 -(QF1(3)+QF2(3))**2  
     $     -(QF1(2)+QF2(2))**2 -(QF1(1)+QF2(1))**2  
         VV = 1D0 -S1/CMSENE**2     
         T10= LOG10(VV)   
      ENDIF   
      CALL GF1(IDA+300,T10,WT1)        
      CALL GF1(IDA+301,T10,WT2)        
      CALL GF1(IDA+302,T10,WT3)        
      CALL GF1(IDA+305,T10,WT2-WT1)    
      CALL GF1(IDA+306,T10,WT3-WT2)    
      CALL GF1(IDA+310,T10,WT10)       
      CALL GF1(IDA+311,T10,WT11)       
      CALL GF1(IDA+320,T10,WT20)       
      CALL GF1(IDA+321,T10,WT21)       
      CALL GF1(IDA+322,T10,WT22)       

      CALL GF1(IDB+300, VV,WT1)        
      CALL GF1(IDB+301, VV,WT2)        
      CALL GF1(IDB+302, VV,WT3)        
      CALL GF1(IDB+305, VV,WT2-WT1)    
      CALL GF1(IDB+306, VV,WT3-WT2)    
      ELSE    
C     ===========      
      WRITE(NOUT,*) '==================================='    
      WRITE(NOUT,*) '============ ROBOL1 ==============='    
      WRITE(NOUT,*) '==================================='    
      CALL GPRINT(IDA+300)  
      CALL GPRINT(IDA+301)  
      CALL GPRINT(IDA+302)  
      CALL GPRINT(IDA+305)  
      CALL GPRINT(IDA+306)  
      CALL GPRINT(IDA+310)  
      CALL GPRINT(IDA+311)  
      CALL GPRINT(IDA+320)  
      CALL GPRINT(IDA+321)  
      CALL GPRINT(IDA+322)  

      CALL GPRINT(IDB+300)  
      CALL GPRINT(IDB+301)  
      CALL GPRINT(IDB+302)  
      CALL GPRINT(IDB+305)  
      CALL GPRINT(IDB+306)  
C----------------------          
      ENDIF   
C     =====   
      END     

      SUBROUTINE ROBOL2(MODE)    
C     ***********************    
C          ===================================
C          ============ ROBOL1 ===============
C          ===================================
C Final state study of v=1-s'/s distribution
C v*rho(v) distribution as a function of log(v)
C total MC result and beta contributions in O(alf0,1,2)
C     ***********************************      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      COMMON / INOUT  / NINP,NOUT   
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT      
      COMMON / INPARM / CMSENE,AMFIN,KEYRAD        
      COMMON / WGTALL / WTMOD,WTCRU1,WTCRU2,WTSET(100)       
      SAVE / INOUT  /,/ MOMSET /,/ INPARM /,/ WGTALL /
      SAVE TMAX,TMIN,NBT,IDA,IDB
C    
      IF(MODE.EQ.-1) THEN        
C     ===================        
      TMAX = 0.0       
      TMIN = -4.0      
      NBT  = 80        
      IDA  = 20000
      CALL GBOOK1(IDA+300,'v*rho(v) O(alf0)         $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+301,'v*rho(v) O(alf1)         $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+302,'v*rho(v) O(alf2)         $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+305,'v*rho(v) O(alf1)-O(alf0) $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+306,'v*rho(v) O(alf2)-O(alf1) $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+310,'v*rho(v)  beta0  O(alf1) $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+311,'v*rho(v)  beta1  O(alf1) $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+320,'v*rho(v)  beta0  O(alf2) $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+321,'v*rho(v)  beta1  O(alf2) $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+322,'v*rho(v)  beat2  O(alf2) $',NBT,TMIN,TMAX)
      NBV = 50
      VMIN= 0
      VMAX= 1
      IDB  = 50000
      CALL GBOOK1(IDB+300,'rho(V) ini O(0)        $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+301,'rho(V) ini O(1)        $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+302,'rho(V) ini O(2)        $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+305,'rho(V) ini O(1-0)      $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+306,'rho(V) ini O(2-1)      $',NBV,VMIN,VMAX)
      ELSEIF(MODE.EQ.0) THEN     
C     ======================     
      WTCRUD =WTCRU1*WTCRU2      
      WT1  = WTCRUD*WTSET(71)    
      WT2  = WTCRUD*WTSET(72)    
      WT3  = WTCRUD*WTSET(73)    
      WT10 = WTCRUD*WTSET(80)    
      WT11 = WTCRUD*WTSET(81)    
      WT20 = WTCRUD*WTSET(90)    
      WT21 = WTCRUD*WTSET(91)    
      WT22 = WTCRUD*WTSET(92)    
C---------//////----->>>>        
      WT=WTMOD 
      VV = 0D0
      T10= -100000000
      IF(NPHOT.NE.0) THEN        
        S1=   (QF1(4)+QF2(4))**2 -(QF1(3)+QF2(3))**2  
     $     -(QF1(2)+QF2(2))**2 -(QF1(1)+QF2(1))**2  
        VV = 1D0 -S1/CMSENE**2     
        T10= LOG10(VV)   
      ENDIF   
      CALL GF1(IDA+300,T10,WT1)        
      CALL GF1(IDA+301,T10,WT2)        
      CALL GF1(IDA+302,T10,WT3)        
      CALL GF1(IDA+305,T10,WT2-WT1)    
      CALL GF1(IDA+306,T10,WT3-WT2)    
      CALL GF1(IDA+310,T10,WT10)       
      CALL GF1(IDA+311,T10,WT11)       
      CALL GF1(IDA+320,T10,WT20)       
      CALL GF1(IDA+321,T10,WT21)       
      CALL GF1(IDA+322,T10,WT22)       

      CALL GF1(IDB+300, VV,WT1)        
      CALL GF1(IDB+301, VV,WT2)        
      CALL GF1(IDB+302, VV,WT3)        
      CALL GF1(IDB+305, VV,WT2-WT1)    
      CALL GF1(IDB+306, VV,WT3-WT2)    
      ELSE    
C     ===========      
      WRITE(NOUT,*) '==================================='    
      WRITE(NOUT,*) '============ ROBOL2 ==============='    
      WRITE(NOUT,*) '==================================='    
      CALL GPRINT(IDA+300)  
      CALL GPRINT(IDA+301)  
      CALL GPRINT(IDA+302)  
      CALL GPRINT(IDA+305)  
      CALL GPRINT(IDA+306)  
      CALL GPRINT(IDA+310)  
      CALL GPRINT(IDA+311)  
      CALL GPRINT(IDA+320)  
      CALL GPRINT(IDA+321)  
      CALL GPRINT(IDA+322)
  
      CALL GPRINT(IDB+300)  
      CALL GPRINT(IDB+301)  
      CALL GPRINT(IDB+302)  
      CALL GPRINT(IDB+305)  
      CALL GPRINT(IDB+306)  
C----------------------          
      ENDIF   
C     =====   
      END     


      SUBROUTINE ROBOL3(MODE)    
C     ***********************    
C          ===================================      
C          ============ ROBOL3 ===============      
C          ===================================      
C Sussex related plots. Initial state.
C Dependence on energy cut on second photon,
C Study on energy/PT of the hardest 3 photons, initial state.
C     ***********************************  
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / INOUT  / NINP,NOUT   
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT      
      COMMON / INPARM / CMSENE,AMFIN,KEYRAD        
      COMMON / WGTALL / WTMOD,WTCRU1,WTCRU2,WTSET(100)       
      SAVE / INOUT  /,/ MOMSET /,/ INPARM /,/ WGTALL /
      DIMENSION  SOFLIM(20)         
      DIMENSION  PT(100),IND(100)               
      DATA LSOF, SOFLIM / 10,    
     $  1D0,  0.100D0,  0.030D0,  0.010D0,  0.003D0, 0.001D0,          
     $ 0.0003D0, 0.0001D0, 0.00003D0, 0.00001,    10*0D0 /   
      SAVE LSOF,SOFLIM,IDE,IDT,NBX,XMIN,XMAX
C   
      IF(MODE.EQ.-1) THEN        
C     ===================        
      IDE = 10050
      IDT = 10060
      CALL GBOOK1(10010,'Photon multiplicity all      $',30,0D0,30D0)
      NBX =    70        
      XMIN= -14.0      
      XMAX=   0.0       
      DO 13 J=1,3      
  13  CALL GBOOK1(IDE+J,'LOG10(E/EEAM)  50+J PHOTON $',NBX,XMIN,XMAX)
      DO 14 J=1,3      
  14  CALL GBOOK1(IDT+J,'LOG10(PT/EEAM) 60+J PHOTON $',NBX,XMIN,XMAX)
C two-dim. controll scatteregram of sudakov variables
C      ZZ= -20D0        
C      CALL GBOOK2(10090,' scatt. log10 $',40,ZZ,0D0, 80,ZZ,0D0) 
      ELSEIF(MODE.EQ.0) THEN     
C     ======================     
      WT=WTMOD         
C...ordering pT      
      CALL ORDPT(PT,IND)         
      DO 18 J=1,3      
      IF(NPHOT.GE.J) THEN        
C...hardest photons  (no need to order!?)    
       ZE=LOG10(2*SPHOT(J,4)/CMSENE)      
       CALL GF1(IDE+J,ZE,WT )        
C...photons with highest pT        
       ZPT=LOG10(2*PT(J)/CMSENE) 
       CALL GF1(IDT+J,ZPT, WT)       
      ENDIF   
   18 CONTINUE         
C   
C controll SCATTERGRAM 
C      DO 27 I=1,NPHOT  
C      XL=  LOG10((SPHOT(I,4)+SPHOT(I,3))/CMSENE)    
C      YL=  LOG10((SPHOT(I,4)-SPHOT(I,3))/CMSENE)    
C      CALL HFILL(10090,XL,YL, WT)   
   27 CONTINUE         
      ELSE    
C     ===========      
      WRITE(NOUT,*) '==================================='    
      WRITE(NOUT,*) '============ ROBOL3 ==============='    
      WRITE(NOUT,*) '==================================='    
C -----------------    
      CALL GPRINT(10010)  
      DO 90 J=1,3
 90   CALL GPRINT(IDE+J)        
      DO 91 J=1,3
 91   CALL GPRINT(IDT+J)        
C----------------------          
      ENDIF   
C     =====   
      END     
      SUBROUTINE ORDPT(PT,IND)   
C     ************************   
C ordering photons according to pT, PT is list of ordered pT 
C and IND is the adress list of photons (indices in SPHOT)   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      DIMENSION PT(*),IND(*)     
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT      
      SAVE   / MOMSET /
      DO 10 I=1,NPHOT   
      PT(I)=SQRT(SPHOT(I,1)**2+SPHOT(I,2)**2)       
   10 IND(I)=I         
      IF(NPHOT.LE.1) RETURN      
      DO 30 I=2,NPHOT   
      DO 30 J=NPHOT,I,-1         
      IF(PT(J).GT.PT(J-1)) THEN  
        X=PT(J)        
        PT(J)=PT(J-1)   
        PT(J-1)=X      
        L=IND(J)       
        IND(J)=IND(J-1)          
        IND(J-1)=L     
      ENDIF   
   30 CONTINUE         
      END    

      SUBROUTINE ROBOL4(MODE)    
C     ***********************    
C          ===================================      
C          ============ ROBOL4 ===============      
C          ===================================      
C Initial + Final state study of V=1-s'/s distribution
C V*rho(V) distribution as a function of log(v)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      COMMON / INOUT  / NINP,NOUT   
      COMMON / INPARM / CMSENE,AMFIN,KEYRAD        
      COMMON / MOMINI / XF1(4),XF2(4),XPHUM(4),XPHOT(100,4),NPHOX      
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT      
      COMMON / WGTALL / WTMOD,WTCRU1,WTCRU2,WTSET(100)       
      SAVE / INOUT  /,/ INPARM /,/ MOMINI /,/ MOMSET /,/ WGTALL /
      SAVE TMAX,TMIN,NBT,IDA,IDB,IEV
C    
      IF(MODE.EQ.-1) THEN        
C     ===================        
      TMAX =   0D0      
      TMIN =  -4D0      
      NBT  =    50        
      IDA  = 30000
      CALL GBOOK1(IDA+300,'V*rho(V) ini O(0)        $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+301,'V*rho(V) ini O(1)        $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+302,'V*rho(V) ini O(2)        $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+305,'V*rho(V) ini O(1-0)      $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+306,'V*rho(V) ini O(2-1)      $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 71,'V*rho(V) ini+fin O(0)    $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 72,'V*rho(V) ini+fin O(1)    $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 73,'V*rho(V) ini+fin O(2)    $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 74,'V*rho(V) ini+fin O(1-0)  $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 75,'V*rho(V) ini+fin O(2-1)  $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 90,'O(2) bt0              $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 91,'O(2) bt1              $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 92,'O(2) bt2              $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 93,'O(2) bt1xbt0          $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 94,'O(2) bt0xbt1          $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 95,'O(2) bt2xbt0          $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 96,'O(2) bt1xbt1          $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 97,'O(2) bt0xbt2          $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 80,'O(2) bt0              $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 81,'O(2) bt1              $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 82,'O(2) bt1xbt0          $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 83,'O(2) bt0xbt1          $',NBT,TMIN,TMAX)
      CALL GBOOK1(IDA+ 84,'O(2) bt2xbt2          $',NBT,TMIN,TMAX)
      NBV = 50
      VMIN= 0
      VMAX= 1
      IDB  = 50000
      CALL GBOOK1(IDB+300,'rho(V) ini O(0)        $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+301,'rho(V) ini O(1)        $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+302,'rho(V) ini O(2)        $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+305,'rho(V) ini O(1-0)      $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+306,'rho(V) ini O(2-1)      $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+ 71,'rho(V) ini+fin O(0)    $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+ 72,'rho(V) ini+fin O(1)    $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+ 73,'rho(V) ini+fin O(2)    $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+ 74,'rho(V) ini+fin O(1-0)  $',NBV,VMIN,VMAX)
      CALL GBOOK1(IDB+ 75,'rho(V) ini+fin O(2-1)  $',NBV,VMIN,VMAX)
      IEV=0
      ELSEIF(MODE.EQ.0) THEN     
C     ======================     
      IEV=IEV+1
      WTCRUD =WTCRU1*WTCRU2      
C initial + Final
      WT1  = WTCRUD*WTSET(71)    
      WT2  = WTCRUD*WTSET(72)    
      WT3  = WTCRUD*WTSET(73)    
      T10  = -10000.
      VV   = 0D0
      IF(NPHOT.NE.0) THEN        
        S1=   (QF1(4)+QF2(4))**2 -(QF1(3)+QF2(3))**2
     $       -(QF1(2)+QF2(2))**2 -(QF1(1)+QF2(1))**2
        VV = 1D0 -S1/CMSENE**2
        T10= LOG10(VV)
      ENDIF
      DO 100 K=71,73
      CALL GF1(IDA+K, T10,WTCRUD*WTSET(K)) 
      CALL GF1(IDB+K, VV ,WTCRUD*WTSET(K)) 
 100  CONTINUE
      CALL GF1(IDA+74,T10,WTCRUD*(WTSET(72)-WTSET(71)))    
      CALL GF1(IDA+75,T10,WTCRUD*(WTSET(73)-WTSET(72)))    
      CALL GF1(IDB+74, VV,WTCRUD*(WTSET(72)-WTSET(71)))    
      CALL GF1(IDB+75, VV,WTCRUD*(WTSET(73)-WTSET(72)))    
C beta contributions first order
      DO 105 K=80,84
 105  CALL GF1(IDA+K, T10,WTCRUD*WTSET(K))        
C beta contributions second order
      DO 110 K=90,97
 110  CALL GF1(IDA+K, T10,WTCRUD*WTSET(K))        
C initial only  (NPHOX, XF1, XF2)
      WT1  = WTCRUD*WTSET(1)    
      WT2  = WTCRUD*WTSET(2)    
      WT3  = WTCRUD*WTSET(3)    
      IF(NPHOX.NE.0) THEN        
      S1=   (XF1(4)+XF2(4))**2 -(XF1(3)+XF2(3))**2  
     $     -(XF1(2)+XF2(2))**2 -(XF1(1)+XF2(1))**2  
      VV = 1D0 -S1/CMSENE**2     
      T10= LOG10(VV)   
      CALL GF1(IDA+ 300,T10,WT1)        
      CALL GF1(IDA+ 301,T10,WT2)        
      CALL GF1(IDA+ 302,T10,WT3)        
      CALL GF1(IDA+ 305,T10,WT2-WT1)    
      CALL GF1(IDA+ 306,T10,WT3-WT2)    
      CALL GF1(IDB+ 300, VV,WT1)        
      CALL GF1(IDB+ 301, VV,WT2)        
      CALL GF1(IDB+ 302, VV,WT3)        
      CALL GF1(IDB+ 305, VV,WT2-WT1)    
      CALL GF1(IDB+ 306, VV,WT3-WT2)    
      ENDIF
      ELSE    
C     ===========      
      WRITE(NOUT,*) '==================================='    
      WRITE(NOUT,*) '============ ROBOL4 ==============='    
      WRITE(NOUT,*) '==================================='    
      DO 600 K=71,75
 600  CALL GPRINT(IDA+K)  
      DO 605 K=80,84
 605  CALL GPRINT(IDA+K)  
      DO 610 K=90,97
 610  CALL GPRINT(IDA+K)  
      CALL GPRINT(IDA+ 300)  
      CALL GPRINT(IDA+ 301)  
      CALL GPRINT(IDA+ 302)  
      CALL GPRINT(IDA+ 305)  
      CALL GPRINT(IDA+ 306)  
      ENDIF
      END


      SUBROUTINE ROBOL5(MODE)    
C     ***********************    
C study on experimental cut-offs 
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / INOUT  / NINP,NOUT   
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT      
      COMMON / INPARM / CMSENE,AMFIN,KEYRAD        
      COMMON / WGTALL / WTMOD,WTCRU1,WTCRU2,WTSET(100)       
      SAVE / INOUT  /,/ MOMSET /,/ INPARM /,/ WGTALL /

      IF(MODE.EQ.-1) THEN        
C     ===================        
      CALL AVRYG( -1,20,' mupair all cuts $',DUM1,0D0,1D0)   
      CALL AVRYG( -1,21,' minimum energy   muons $',DUM1,0D0,1D0)      
      CALL AVRYG( -1,22,' minimum costheta muons $',DUM1,0D0,1D0)      
      CALL AVRYG( -1,23,' acollinearity $',DUM1,0D0,1D0)     
      CALL GBOOK1(  70,'log dN/dv     -all           $',40, 0D0,1D0)   
      CALL GBOOK1(  71,'log dN/dv    acoll cut       $',40, 0D0,1D0)   
      CALL GIDOPT(70,'LOGY')     
      CALL GIDOPT(71,'LOGY')     
cc      CALL GBOOK2(200,' acol/v-var.  $',40,0D0 ,40D0, 50,0D0,1.00D0)   
      ELSEIF(MODE.EQ.0) THEN     
C     ======================     
      WT=WTMOD         
C define mupair cut-off          
      CALL DEFMUP(W1,W2,W3)      
      WW=WT*W1*W2*W3   
      CALL AVRYG(  0, 20,' ',WW,0D0,0D0)  
      CALL AVRYG(  0, 21,' ',W1,0D0,0D0)  
      CALL AVRYG(  0, 22,' ',W2,0D0,0D0)  
      CALL AVRYG(  0, 23,' ',W3,0D0,0D0)  
      S1=   (QF1(4)+QF2(4))**2 -(QF1(3)+QF2(3))**2  
     $     -(QF1(2)+QF2(2))**2 -(QF1(1)+QF2(1))**2  
      VV = 1D0 -S1/CMSENE**2     
      CALL GF1(  70, VV, WT)        
      CALL GF1(  71, VV, W3)        
      ACOL=0D0         
      IF(NPHOT.NE.0) ACOL=       
     $ ACOS(-(QF1(1)*QF2(1)+QF1(2)*QF2(2)+QF1(3)*QF2(3))     
     $          /SQRT((QF1(1)**2 +QF1(2)**2 +QF1(3)**2)*     
     $                (QF2(1)**2 +QF2(2)**2 +QF2(3)**2)))*180/3.141593 
cc      CALL HFILL( 200, ACOL,VV,  WT)      
      ELSE    
C     ====    
      WRITE(NOUT,*) '==================================='    
      WRITE(NOUT,*) '============ ROBOL5 ==============='    
      WRITE(NOUT,*) '==================================='    
      CALL AVRYG(110, 20,' ', XAV,XER,XNEV)         
      CALL AVRYG(110, 21,' ', XAV,XER,XNEV)         
      CALL AVRYG(110, 22,' ', XAV,XER,XNEV)         
      CALL AVRYG(110, 23,' ', XAV,XER,XNEV)         
      CALL GPRINT(70)  
      CALL GPRINT(71)  
cc      CALL GPRINT(200) 
      ENDIF   
      END     
      SUBROUTINE DEFMUP(W1,W2,W3)         
C     ***************************         
C-------------------------------------------------------------------   
C  MARKII-like cuts from Bennie: 
C  visible muon is     
C        |cos(theta-mu)|     < 0.80;      
C        E-mu       > 2.0 GeV;   
C  visible gammas are  
C        |cos(theta-gamma)|  < 0.95;      
C        E-gamma             > 0.2 GeV;   
C  event is accepted if there are two visible muons and      
C        E-visible           > 0.1*sqrt(s),         
C  where E-visible includes the visible mu-mu-bar and gamma energy.    
C-------------------------------------------------------------------   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
      COMMON / MOMSET / QF1(4),QF2(4),SPHUM(4),SPHOT(100,4),NPHOT      
      COMMON / INPARM  / CMSENE,AMFIN,KEYRAD        
      SAVE / MOMSET /,/ INPARM  /

      W1=1D0  
      W2=1D0  
      W3=1D0  
      CMULIM=0.80D0    
      EMULIM=5.0D0     
      CGALIM=0.95D0    
      EGALIM=0.2D0     
      XVSLIM=0.3D0     
      ACOLIM=20.D0     
C two visible muons    
      IF(QF1(4).LT.EMULIM) W1=0D0         
      IF(QF2(4).LT.EMULIM) W1=0D0         
      COST1= QF1(3)/SQRT(QF1(1)**2+QF1(2)**2+QF1(3)**2)      
      IF(ABS(COST1).GT.CMULIM) W2=0D0     
      COST2= QF2(3)/SQRT(QF2(1)**2+QF2(2)**2+QF2(3)**2)      
      IF(ABS(COST2).GT.CMULIM) W2=0D0     
C minimum visible energy         
C     EVIS= QF1(4)+QF2(4)        
C     DO 10 I=1,NPHOT  
C     COSTG= SPHOT(I,3)/SQRT(SPHOT(I,1)**2+SPHOT(I,2)**2+SPHOT(I,3)**2)
C     EG= SPHOT(I,4)   
C     IF(ABS(COSTG).LT.CGALIM.AND.EG.GT.EGALIM)  EVIS=EVIS+EG          
C  10 CONTINUE         
C     IF(EVIS.LT.XVSLIM*CMSENE) W3=0D0    
C acollinearity        
      ACOL=0D0         
      IF(NPHOT.NE.0) THEN        
         DQ12= QF1(1)*QF2(1) +QF1(2)*QF2(2) +QF1(3)*QF2(3)   
         QQ1 = QF1(1)**2 +QF1(2)**2 +QF1(3)**2      
         QQ2 = QF2(1)**2 +QF2(2)**2 +QF2(3)**2      
         ACOL= ACOS(-DQ12/SQRT(QQ1*QQ2))*180/3.141593        
      ENDIF   
      IF(ACOL.GT.ACOLIM) W3=0D0  
      END     

      SUBROUTINE AVRYG(MODE,ID,TITLE, X,XMIN,XMAX)  
C     ********************************************  
C Utility program for calculating up to IDMAX averages.      
C IF(MODE.EQ.-1) THEN   
C          Initialization of entry ID,    
C          TITLE is up to 32 character title, last character 
C                 must necessarily be a $  
C          X ignored, XMIN and XMAX are limits on X.         
C ELSEIF(MODE.EQ.0) THEN         
C          Summing up X value for a given entry ID, 
C          (X is summed up in average even if outside XMIN,XMAX),      
C          TITLE, XMIN, XMAX ignored.     
C ELSEIF(MODE.GE.1) THEN         
C          X    = average <x>    
C          XMIN = absolute error 
C          XMAX = Number of all sampled events      
C          Printout depending on the value of the MODE       
C               MODE=1       -none        
C               MODE=2       -title  only  
C               MODE=10,100  -partial     
C               MODE=110     -maximal     
C ENDIF       
C     ************************   
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)  
      PARAMETER(IDMAX=80,LENTIT=32)       
      CHARACTER*32 TITLE         
      COMMON / CVRYG  / AVERX,ERRELX,NEVTOT,NEVACC,NEVUND,NEVOVE,NEVZER
      COMMON / INOUT  / NINP,NOUT   
      SAVE / CVRYG  /,/ INOUT  /
      CHARACTER*32 MTITLE(IDMAX) 
      DIMENSION  NTOT(IDMAX),   NACC(IDMAX)         
      DIMENSION  NUND(IDMAX),   NOVE(IDMAX),   NZER(IDMAX)   
      DIMENSION    SWT(IDMAX),  SSWT(IDMAX)         
      DIMENSION  BBMIN(IDMAX), BBMAX(IDMAX)         
      DIMENSION  XXMIN(IDMAX), XXMAX(IDMAX)         
      LOGICAL MET      
      DATA  NTOT    /IDMAX*-1/    SWT   /IDMAX*0D0/  SSWT /IDMAX*0D0/  
      DATA XXMIN /IDMAX*-1D20/  XXMAX /IDMAX*-1D20/ 
      DATA BBMIN /IDMAX*-1D20/  BBMAX /IDMAX*-1D20/ 
      SAVE MTITLE,NTOT,NACC,NUND,NOVE,NZER,SWT,SSWT
      SAVE BBMIN,BBMAX,XXMIN,XXMAX

      IF(ID.LE.0.OR.ID.GT.IDMAX) THEN     
           WRITE(NOUT,*) ' =====AVRYG: WRONG ID'    
           STOP        
      ENDIF   
C Initialization       
      IF(MODE.EQ.-1) THEN        
           NTOT(ID)=0           
           NACC(ID)=0           
           NUND(ID)=0           
           NOVE(ID)=0           
           NZER(ID)=0           
           SWT(ID)   =0D0       
           SSWT(ID)  =0D0       
           XXMAX(ID)  = -1D+30  
           XXMIN(ID)  = +1D+30  
           BBMAX(ID)  = XMAX    
           BBMIN(ID)  = XMIN    
C        Storing the title      
           MET = .FALSE.        
           DO 10 I=1,LENTIT     
           IF( TITLE(I:I).EQ.'$' .OR. MET )   THEN 
             MTITLE(ID)(I:I)=  '='        
             MET=.TRUE.         
           ELSE        
             MTITLE(ID)(I:I)=TITLE(I:I)   
           ENDIF       
  10       CONTINUE    
C suming up the contributions   
      ELSEIF(MODE.EQ.0) THEN    
           IF(NTOT(ID).LT.0) THEN         
              WRITE(NOUT,*) ' ==== WARNING FROM AVRYG: '     
              WRITE(NOUT,*) ' LACK OF INITIALIZATION, ID=',ID         
           ENDIF       
           NTOT(ID)  =NTOT(ID) +1         
           SWT(ID)   =SWT(ID)  +X         
           SSWT(ID)  =SSWT(ID) +X*X       
           XXMAX(ID)= MAX(XXMAX(ID), X)   
           XXMIN(ID)= MIN(XXMIN(ID), X)   
           IF( X.EQ.0D0)   NZER(ID)=NZER(ID)+1     
           IF(     X.LT.BBMIN(ID))  THEN  
             NUND(ID) = NUND(ID)+1        
           ELSEIF( X.GT.BBMAX(ID))  THEN  
             NOVE(ID) = NOVE(ID)+1        
           ELSE        
             NACC(ID) = NACC(ID)+1        
           ENDIF       
C calculating averages - final report     
      ELSEIF( MODE.GE.1) THEN   
           IF(NTOT(ID).LE.0.OR.SWT(ID).EQ.0D0)  THEN         
              AVERX  =0D0       
              ERRELX =0D0       
           ELSE        
              AVERX =SWT(ID)/FLOAT(NTOT(ID))       
              VARIA =SSWT(ID)/NTOT(ID)-(SWT(ID)/NTOT(ID))**2 
              ERROX =SQRT(ABS(VARIA)/NTOT(ID))     
           ENDIF       
           NEVTOT=NTOT(ID)      
           NEVACC=NACC(ID)      
           NEVUND=NUND(ID)      
           NEVZER=NZER(ID)      
           NEVOVE=NOVE(ID)      
           X    =AVERX          
           XMIN =ERROX          
           XMAX =NEVTOT         
           K1= MOD((MODE/10 ),10)         
           K2= MOD((MODE/100),10)         
 1000 FORMAT(1X,A,I2,A,A,A)     
           IF(MODE.GT.1) WRITE(NOUT,1000)          
     $      '========[', ID, ']============' ,MTITLE(ID),    
     $      '======================'      
 1003 FORMAT(1X,A,4A17,A / 1X,A,4E17.9,A)          
           IF(K1.EQ.1) WRITE(NOUT,1003)   
     $      '====','< x >','abs_err', 'Min(x)'  , 'Max(x)'  ,'  ====' 
     $     ,'====', AVERX ,  ERROX  ,  XXMIN(ID),  XXMAX(ID),'  ====' 
 1004 FORMAT(1X,A,5(A,I6),A)    
           IF(K2.EQ.1) WRITE(NOUT,1004)   
     $     '====   ','  Ntot=',NTOT(ID),'  Nacc=',NACC(ID)   
     $              ,'  Nund=',NUND(ID),'  Nove=',NOVE(ID)   
     $              ,'  Nzer=',NZER(ID),'  ===='   
      ELSE   
           WRITE(NOUT,*) ' =====AVRYG:  WRONG MODE'          
           STOP        
      ENDIF  
      END    
